//draw.cpp


#include <stdafx.h>




#include "os.h"
#include "wimp.h"
#include "flex.h"

#include "transform.h"
#include "xmath.h"
#include "etc.h"
#include "alloc.h"

#include "osglue.h"
#include "osgraphics.h"
#include "deb.h"
#include "colour.h"


#include "drawcurves.h"

#include "drawmod.h"






os_error * Draw_ExpandPath(int * p,transformstr * tr,int flags)
{
 int     over;
 POINT   pt[3];
	int     subpath;
	POINT			sx;



 over=0;
	subpath=0;

 while(!over)
 {
  switch(*p++)
  {
   case     DRAWEND:
                    over=1;
                    break;

   case    DRAWMOVE:
   case DRAWMOVESUB:
																				subpath=1;
																				sx.x=p[0];
																				sx.y=p[1];

			case	DRAWMOVEGAP:


                    pt[0].x=*p++;
                    pt[0].y=*p++;
                    if(tr) tr_transformset((coordstr*)pt,1,tr);
                    if(flags & DRAWMOD_OSUNITS)
                    {
                     MoveToEx(currenthdcptr->hdc,GRDXPIX(pt[0].x),GRDYPIX(pt[0].y),NULL);
                    }
                    else
                    if(flags & DRAWMOD_FONTUNITS)
                    {
                     MoveToEx(currenthdcptr->hdc,GRFXPIX(pt[0].x),GRFYPIX(pt[0].y),NULL);
                    }
                    else
                    {
                     MoveToEx(currenthdcptr->hdc,(pt[0].x),(pt[0].y),NULL);
                    }

//                    cprintf("move to %d %d",pt[0].x,pt[0].y);
                    break;

   case    DRAWDRAW:
                    pt[0].x=*p++;
                    pt[0].y=*p++;
                    if(tr) tr_transformset((coordstr*)pt,1,tr);

                    if(flags & DRAWMOD_OSUNITS)
                    {
                     LineTo(currenthdcptr->hdc,GRDXPIX(pt[0].x),GRDYPIX(pt[0].y));
                    }
                    else
                    if(flags & DRAWMOD_FONTUNITS)
                    {
                     LineTo(currenthdcptr->hdc,GRFXPIX(pt[0].x),GRFYPIX(pt[0].y));
                    }
                    else
                    {
                     LineTo(currenthdcptr->hdc,(pt[0].x),(pt[0].y));
                    }
                    
//                    LineTo(currenthdcptr->hdc,GRXPIX(pt[0].x),GRYPIX(pt[0].y));
//                    cprintf("line to %d %d",pt[0].x,pt[0].y);
                    break;

   case   DRAWCURVE:
                    pt[0].x=*p++;
                    pt[0].y=*p++;
                    pt[1].x=*p++;
                    pt[1].y=*p++;
                    pt[2].x=*p++;
                    pt[2].y=*p++;
                    if(tr) tr_transformset((coordstr*)pt,3,tr);
                    if(flags & DRAWMOD_OSUNITS)
                    {
                     pt[0].x=GRDXPIX(pt[0].x);
																			 	pt[0].y=GRDYPIX(pt[0].y);
																			 	pt[1].x=GRDXPIX(pt[1].x);
																			 	pt[1].y=GRDYPIX(pt[1].y);
																			 	pt[2].x=GRDXPIX(pt[2].x);
																			 	pt[2].y=GRDYPIX(pt[2].y);
																				}
                    else
                    if(flags & DRAWMOD_FONTUNITS)
                    {
                     pt[0].x=GRFXPIX(pt[0].x);
																			 	pt[0].y=GRFYPIX(pt[0].y);
																			 	pt[1].x=GRFXPIX(pt[1].x);
																			 	pt[1].y=GRFYPIX(pt[1].y);
																			 	pt[2].x=GRFXPIX(pt[2].x);
																			 	pt[2].y=GRFYPIX(pt[2].y);
                    }
                    else
                    {
                     pt[0].x=(pt[0].x);
																			 	pt[0].y=(pt[0].y);
																			 	pt[1].x=(pt[1].x);
																			 	pt[1].y=(pt[1].y);
																			 	pt[2].x=(pt[2].x);
																			 	pt[2].y=(pt[2].y);
                    }
                    PolyBezierTo(currenthdcptr->hdc,pt,3);
                    break;

   case   DRAWCLOSE:
																				if(subpath)
																				{
                     pt[0]=sx;

                     if(tr) tr_transformset((coordstr*)pt,1,tr);

                     if(flags & DRAWMOD_OSUNITS)
                     {
                      LineTo(currenthdcptr->hdc,GRDXPIX(pt[0].x),GRDYPIX(pt[0].y));
                     }
                     else
                     if(flags & DRAWMOD_FONTUNITS)
                     {
                      LineTo(currenthdcptr->hdc,GRFXPIX(pt[0].x),GRFYPIX(pt[0].y));
                     }
                     else
                     {
                      LineTo(currenthdcptr->hdc,(pt[0].x),(pt[0].y));
                     }
																				}


  case	DRAWCLOSEGAP:
//                    CloseFigure(currenthdcptr->hdc);
//                    if(*(p-1)==DRAWCLOSE) cprintf("close");
//																				else																	 cprintf("close gap");

// the problem with using closefigure is that on Win subpaths are started by MoveToEx
// there is no equivalent of DRAWMOVEGAP
// However CloseFigure closes with a join, DIY should be OK as long as this code is only
// ever called with thin lines. If thickening is left to our own higher level code...


																				subpath=0;
                    break;
  }
 }

 return(NULL);
}



os_error * Draw_Stroke(int * path,int thickness,int flags,int * caps,transformstr * tr,int style,int flatness)
{
 os_error   * err;
 int        * dest;
 int        * dest2;
 int        * dest3;


 cprintf("drawstroke thick %d flags %x caps %x",thickness,flags,caps!=NULL);


 err=draw_flatten(path,&dest,flatness);
 if(!err)
 {
  if(style) err=draw_dash(dest,&dest2,(int*)style);
  else      dest2=dest;

  if(!err)
  {
   if(thickness)
   {
    err=draw_thicken(dest2,&dest3,thickness,caps);
   }
   else dest3=dest2;

   if(!err)
   {
    BeginPath(currenthdcptr->hdc);

    Draw_ExpandPath(dest3,tr,flags);

    EndPath(currenthdcptr->hdc);

    if(thickness)
    {
     int mode=SetPolyFillMode(currenthdcptr->hdc,WINDING);
     graphicscreatepen2(PS_SOLID,0,currentcolour,currenthdcptr);
  
     StrokeAndFillPath(currenthdcptr->hdc);

     SetPolyFillMode(currenthdcptr->hdc,mode);
    }
    else
    {
     graphicscreatepen2(PS_SOLID,0,currentcolour,currenthdcptr);

     StrokePath(currenthdcptr->hdc);
    }

    if(thickness) sfree((flex_ptr)&dest3);
   }

   if(style) sfree((flex_ptr)&dest2);
  }
  sfree((flex_ptr)&dest);
 }


 return(err);
}




/*

 winding rule
 bits 0,1   0 non-zero winding rule
												1	-ve winding rule
												2 even odd
												3 +ve
	bits 2-5   boundary plotting

*/


os_error * Draw_Fill(int * path,transformstr * tr,int windingrule,int flatness,int flags)
{
 os_error   * err;
	int          mode;


 err=NULL;

 BeginPath(currenthdcptr->hdc);

 Draw_ExpandPath(path,tr,flags);

 EndPath(currenthdcptr->hdc);

 mode=SetPolyFillMode(currenthdcptr->hdc,((windingrule & 0x3)==2)?ALTERNATE:WINDING);

 FillPath(currenthdcptr->hdc);

 SetPolyFillMode(currenthdcptr->hdc,mode);

 return(err);

 USE(flatness);
}






os_error * Draw_Bounds(int * path,int thickness,int flags,int * caps,int style,int windingrule,coordstr * cx)
{
 os_error   * err;
 int        * dest;
 int        * dest2;
 int        * dest3;


 err=NULL;


 err=draw_flatten(path,&dest,0);
 if(!err)
 {
  if(style) err=draw_dash(dest,&dest2,(int*)style);
  else      dest2=dest;

  if(!err)
  {
   if(thickness)
   {
    err=draw_thicken(dest2,&dest3,thickness,caps);
   }
   else dest3=dest2;

   if(!err)
   {
				draw_bounds(dest3,cx);

    if(thickness) sfree((flex_ptr)&dest3);
   }

   if(style) sfree((flex_ptr)&dest2);
  }
  sfree((flex_ptr)&dest);
 }


 return(err);

	USE(windingrule);
	USE(flags);
}










os_error * Draw_ProcessPath(int * path,int * out,int outsize,int flags,int flatness,int * caps,int thickness,int style,int windingrule)
{
 os_error   * err;
 int        * dest;
 int        * dest2;
 int        * dest3;


 err=NULL;


 err=draw_flatten(path,&dest,0);
 if(!err)
 {
  if(style) err=draw_dash(dest,&dest2,(int*)style);
  else      dest2=dest;

  if(!err)
  {
   if(thickness)
   {
    err=draw_thicken(dest2,&dest3,thickness,caps);
   }
   else dest3=dest2;

   if(!err)
   {
				draw_copy(dest3,out,outsize);
		
    if(thickness) sfree((flex_ptr)&dest3);
   }

   if(style) sfree((flex_ptr)&dest2);
  }
  sfree((flex_ptr)&dest);
 }


 return(err);

	USE(windingrule);
	USE(flags);
}








#ifdef NEVER

os_error * Draw_Bounds(int * path,int thickness,int flags,int * caps,int style,int windingrule,coordstr * cx)
{
 os_error     * err;
 POINT        * px;
 POINT        * pxp;
 POINT        * pxplt;
 BYTE         * ptype;
 BYTE         * ptypep;
 int            xmin;
 int            xmax;
 int            ymin;
 int            ymax;
 int            npoints;
// transformstr   trb;
 transformstr * tr;

 err=NULL;

 tr=NULL;

 if(flags & DRAWMOD_OSUNITS)
 {
  thickness/=256;
//  tr_setscale(&trb,256,1,256,1);
//  tr=&trb;
 }

 if(flags & DRAWMOD_FONTUNITS)
 {
  thickness/=400;
//  tr_setscale(&trb,400,1,400,1);
//  tr=&trb;
 }


 err=graphicscheck(1);
 if(!err)
 {
//  graphicsostext2(currenthdcptr);

  BeginPath(currenthdcptr->hdc);

  Draw_ExpandPath(path,tr,flags);

  EndPath(currenthdcptr->hdc);

//  npoints=GetPath(currenthdcptr->hdc,NULL,NULL,0);
//  cprintf("npoints %d",npoints);

  if(thickness>1)
  {
   LOGBRUSH lb;

   lb.lbColor=currentcolour;
   lb.lbHatch=0;
   lb.lbStyle=BS_SOLID;

   graphicscreatepenext2(PS_GEOMETRIC|PS_SOLID,thickness,&lb,0,NULL,currenthdcptr);

   WidenPath(currenthdcptr->hdc);
  }
  else
  {
   FlattenPath(currenthdcptr->hdc);
  }

  npoints=GetPath(currenthdcptr->hdc,NULL,NULL,0);
//    cprintf("npoints %d",npoints);

  err=flex_alloc((flex_ptr)&px,sizeof(POINT)*npoints);
  if(!err)
  {
   err=flex_alloc((flex_ptr)&ptype,sizeof(BYTE)*npoints);
   if(!err)
   {
    GetPath(currenthdcptr->hdc,px,ptype,npoints);

    pxp=px;
    ptypep=ptype;
    pxplt=pxp+npoints;

    xmin=xmax=pxp->x;
    ymin=ymax=pxp->y;

    pxp++;
    ptypep++;

    while(pxp<pxplt)
    {
//	cprintf("px x %d y %d",pxp->x,pxp->y);
     if(pxp->x<xmin) xmin=pxp->x;
     if(pxp->x>xmax) xmax=pxp->x;
     if(pxp->y<ymin) ymin=pxp->y;
     if(pxp->y>ymax) ymax=pxp->y;
     pxp++;
    }

    if(flags & DRAWMOD_OSUNITS)
    {
     xmin=GRINVDXPIX(xmin);
     xmax=GRINVDXPIX(xmax);
     ymin=GRINVDYPIX(ymin);
     ymax=GRINVDYPIX(ymax);
    }

//				cprintf("xmin %d xmax %d ymin %d ymax %d",xmin,xmax,ymin,ymax);

    if(flags & DRAWMOD_FONTUNITS)
    {
     xmin=GRINVFXPIX(xmin);
     xmax=GRINVFXPIX(xmax);
     ymin=GRINVFYPIX(ymin);
     ymax=GRINVFYPIX(ymax);
    }

    cx->x=xmin;
    cx->y=ymin;
    cx++;
    cx->x=xmax;
    cx->y=ymax;

    flex_free((flex_ptr)&px);
   }
   flex_free((flex_ptr)&ptype);
  }
//  graphicsriscos2(currenthdcptr);
  graphicsclear();
 }

 return(err);

 USE(windingrule);
 USE(style);
 USE(caps);
}




os_error * Draw_ProcessPath(int * path,int * out,int outsize,int flags,int flatness,int * caps,int thickness,int style,int windingrule)
{
 os_error * err;
 int        * p;
 POINT      * px;
 POINT      * pxp;
 POINT      * pxplt;
 BYTE       * ptype;
 BYTE       * ptypep;
 int          npoints;
 int        * outlt;

 err=NULL;


 err=graphicscheck(1);
 if(!err)
 {
  BeginPath(currenthdcptr->hdc);

  Draw_ExpandPath(path,NULL,0);

  EndPath(currenthdcptr->hdc);

//  npoints=GetPath(currenthdcptr->hdc,NULL,NULL,0);

  if(thickness>1)
  {
   LOGBRUSH lb;

   lb.lbColor=currentcolour;
   lb.lbHatch=0;
   lb.lbStyle=BS_SOLID;

   graphicscreatepenext2(PS_GEOMETRIC|PS_SOLID,thickness,&lb,0,NULL,currenthdcptr);

   WidenPath(currenthdcptr->hdc);
  }
  else
  {
   FlattenPath(currenthdcptr->hdc);
  }

  npoints=GetPath(currenthdcptr->hdc,NULL,NULL,0);

  err=flex_alloc((flex_ptr)&px,sizeof(POINT)*npoints);
  if(!err)
  {
   err=flex_alloc((flex_ptr)&ptype,sizeof(BYTE)*npoints);
   if(!err)
   {
    GetPath(currenthdcptr->hdc,px,ptype,npoints);

    pxp=px;
    ptypep=ptype;
    pxplt=pxp+npoints;
    outlt=out+outsize/sizeof(int);
    p=out;

//    cprintf("npoints=%d",npoints);

    while(pxp<pxplt)
    {

     switch(*ptypep)
     {
      case   PT_MOVETO:
                       *p++=DRAWMOVE;
                       *p++=pxp->x;
                       *p++=pxp->y;
                       break;

      case   PT_LINETO:
                       *p++=DRAWDRAW;
                       *p++=pxp->x;
                       *p++=pxp->y;
                       break;

      case PT_BEZIERTO:
                       break;
     }

     if(p>(outlt-3)) break;
     pxp++;
     ptypep++;
    }

    *p++=DRAWEND;

    flex_free((flex_ptr)&px);
   }
   flex_free((flex_ptr)&ptype);
  }
  graphicsclear();
 }

 return(err);

 USE(windingrule);
 USE(style);
 USE(caps);
 USE(flags);
 USE(flatness);
}

#endif



