/*->c.sprite */

#include <stdafx.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>

#include "os.h"
#include "wimp.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"



#include "osglue.h"
#include "osunits.h"
#include "osgraphics.h"
#include "ossprite.h"
#include "colour.h"
#include "xmath.h"


#include "etc.h"
#include "bits.h"
#include "deb.h"
#include "fsx.h"






os_error * sprite_area_merge_memory(sprite_area * area,char * merge)
{
 sprite_header * rshdr;
 sprite_header * wshdr;
 sprite_area   * spa;
 int             nsprite;

 spa=(sprite_area*)(merge-sizeof(int));
 rshdr=(sprite_header*)(((char*)spa)+spa->sproff);
 wshdr=(sprite_header*)(((char*)area)+area->freeoff);
 nsprite=spa->number;

 while(nsprite--)
 {
  XMEMCPYX(wshdr,rshdr,rshdr->next);
  area->number++;
  area->freeoff+=rshdr->next;

  wshdr=(sprite_header*)(((char*)wshdr)+wshdr->next);
  rshdr=(sprite_header*)(((char*)rshdr)+rshdr->next);
 }

 return(NULL);
}




os_error * sprite_area_merge(sprite_area *area,const char *filename)
{
 os_error      * err;
 sprite_header * shdr;
 int             number;
 int             sproff=0;
 int             freeoff=0;
 fshandle        fh;

// cprintf("merge %S",filename);

 err=fs_open((char*)filename,'r',&fh);
 if(!err)
 {
           err=fs_read(fh,&number,sizeof(int));
  if(!err) err=fs_read(fh,&sproff,sizeof(int));
  if(!err) err=fs_read(fh,&freeoff,sizeof(int));
  if(!err) err=fs_seek(fh,sproff-4);

//  cprintf("number %d sproff %d freeoff %d",number,sproff,freeoff);
  
  if(!err)
  {
   shdr=(sprite_header*)(((char*)area)+area->freeoff);
   err=fs_read(fh,shdr,(freeoff-sproff));
//   cprintf("next %d shift %d",shdr->next,freeoff-sproff);
   if(!err)
   {
    area->number+=number;
    area->freeoff+=(freeoff-sproff);
   }
  }

  err=fs_close(fh,err);
 }

 return(err);
}




void sprite_area_initialise(sprite_area *area, int length)
{
  area->size    = length; /* No SpriteOp to do this ! */
  area->number  = 0;
  area->sproff  = 16;
  area->freeoff = 16;
}






static void setfromtag(sprite_area *area, sprite_id *spr,newsprite_header ** sphp)
{
 if (area == sprite_mainarea)
 {
  // r->r[0] = op;
  // r->r[1] unused */
  *sphp=NULL;          // can't do anything in this case, system sprite area...
 }
 else
 {
  if((spr->tag)==sprite_id_addr)
  {
   // r->r[0] = 512 + op;
   *sphp=(newsprite_header*)(spr->s.addr);
  }
  else
  {
   // r->r[0] = 256 + op;
   *sphp=sprite_find(area,spr->s.name);
  }
 }
}



os_error * sprite_put_givenpx(sprite_area *area, sprite_id *spr, int gcol_action,
                            int x, int y)
{
 os_error      * err;
 newsprite_header * sph;


 setfromtag(area,spr,&sph);

 y-=sph->height;

 err=sprite_render(sph,currenthdcptr->hdc,x,y);   // x,y top left of sprite

 return(err);

 USE(gcol_action);
}


os_error * sprite_put_given(sprite_area *area, sprite_id *spr, int gcol_action,
                            int x, int y)
{
 os_error      * err;
 newsprite_header * sph;
// POINT           pt;

 setfromtag(area,spr,&sph);
/*
 pt.x=x;
 pt.y=y;
 LPtoDP(currenthdcptr->hdc,&pt,1);
 x=pt.x;
 y=pt.y;
*/
 
 
 x=GRXPIX(x);
 y=GRYPIX(y);

// graphicsostext2(currenthdcptr);

// x=xos2pix(x);
// y=-yos2pix(y);
 y-=sph->height;

// cprintf("x=%d y=%d",x,y);
 err=sprite_render(sph,currenthdcptr->hdc,x,y);   // x,y top left of sprite

// graphicsriscos2(currenthdcptr);


 return(err);

 USE(gcol_action);
}









newsprite_header * sprite_find(sprite_area * areap,char * name)
{
 int * p;
 int * q;
 int   last;
 int   offset;

 offset=areap->sproff;      /* offset to first sprite */
 last=areap->freeoff;

 p=(int*)areap;
 q=p+(last/sizeof(int));

 while(1)
 {
  p+=(offset/sizeof(int));  /* point to first sprite */
		if(p>=q) break;

  offset=*p;

  if(!cstrncmp((char*)(p+1),name,12))
  {
   return((newsprite_header*)p);
  }
 }

 return(NULL);
}




os_error * sprite_put_scaled(sprite_area *area, sprite_id *spr,
                             int gcol_action,
                             int x, int y,
                             sprite_factors  *factors,
                             sprite_pixtrans *pixtrans)
{
 os_error      * err;
 newsprite_header * sph;
// POINT           pt;
 int             dxpix;
 int             dypix;
 int             xpix;
 int             ypix;

 setfromtag(area,spr,&sph);
 getspritesize((newsprite_header*)sph,&xpix,&ypix,NULL);

/*
 pt.x=x;
 pt.y=y;
 LPtoDP(currenthdcptr->hdc,&pt,1);
 x=pt.x;
 y=pt.y;
*/ 
// graphicsostext2(currenthdcptr);

 x=GRXPIX(x);
 y=GRYPIX(y);


// y-=sph->height;

 if(factors)
 {
  dxpix=scale(xpix,factors->xmag,factors->xdiv);
  dypix=scale(ypix,factors->ymag,factors->ydiv);
 }
 else
 {
  dxpix=xpix;
  dypix=ypix;
 }

// y-=sph->height;
// sprite_render(sph,currenthdcptr->hdc,x,y);   // x,y top left of sprite

 err=sprite_renderscaled(sph,currenthdcptr->hdc,x,y,dxpix,dypix,pixtrans,NULL);   // x,y top left of sprite

// graphicsriscos2(currenthdcptr);

 return(err);

 USE(gcol_action);
}




os_error * sprite_put_scaledpx(sprite_area *area, sprite_id *spr,
                             int gcol_action,
                             int x, int y,
                             sprite_factors  *factors,
                             sprite_pixtrans *pixtrans)
{
 os_error      * err;
 newsprite_header * sph;
 int             dxpix;
 int             dypix;
 int             xpix;
 int             ypix;

 setfromtag(area,spr,&sph);
 getspritesize((newsprite_header*)sph,&xpix,&ypix,NULL);

 if(factors)
 {
  dxpix=scale(xpix,factors->xmag,factors->xdiv);
  dypix=scale(ypix,factors->ymag,factors->ydiv);
 }
 else
 {
  dxpix=xpix;
  dypix=ypix;
 }

 err=sprite_renderscaled(sph,currenthdcptr->hdc,x,y,dxpix,dypix,pixtrans,NULL);   // x,y top left of sprite

 return(err);

 USE(gcol_action);
}






#ifdef NEVER

os_error * sprite_put_trans(sprite_area *area,sprite_id *spr,int gcol_action,
                            sprite_transform * trans,sprite_pixtrans *pixtrans)
{
 os_error       * err;
 sprite_header  * sph;
// POINT            pt;
 POINT            pts[4];
 int              xdpi;
 int              ydpi;
 int              xpix;
 int              ypix;
// int              x;
// int              y;
// sprite_factors   factors;
 coordstr       * cx;
 int              i;
 int              regular;

 setfromtag(area,spr,&sph);

 if(gcol_action & (1<<8))
 {
  cx=(coordstr*)trans;

  for(i=0;i<4;i++)
  {
   pts[i].x=GRDXPIX(cx[i].x);
   pts[i].y=GRDYPIX(cx[i].y);
  }
 }
 else
 {
  getspriteinfo((newsprite_header*)sph,&xdpi,&ydpi,NULL);
  getspritesize((newsprite_header*)sph,&xpix,&ypix,NULL);

  pts[0].x=0;
  pts[0].y=(ypix*180*256)/ydpi;
  pts[1].x=(xpix*180*256)/xdpi;
  pts[1].y=pts[0].y;
  pts[2].x=pts[1].x;
  pts[2].y=0;
  pts[3].x=0;
  pts[3].y=0;

  tr_transformset((coordstr*)pts,4,(transformstr*)trans);

  for(i=0;i<4;i++)
  {
   pts[i].x=GRDXPIX(pts[i].x);
   pts[i].y=GRDYPIX(pts[i].y);
  }
 }



//  LPtoDP(currenthdcptr->hdc,pts,4);

//  graphicsostext2(currenthdcptr);

  regular=(pts[0].y==pts[1].y && pts[2].y==pts[3].y &&
           pts[0].x==pts[3].x && pts[1].x==pts[2].x);

//  cprintf("regular %d",regular);

  if(regular)
  {
   err=sprite_renderscaled(sph,currenthdcptr->hdc,pts[0].x,pts[3].y,pts[1].x-pts[0].x,pts[3].y-pts[0].y,pixtrans,NULL);   // x,y top left of sprite
  }
  else
  {
   err=sprite_renderbox(sph,currenthdcptr,pts,pixtrans,NULL);
  }

//  graphicsriscos2(currenthdcptr);
  
  return(err); // passed rectangle

#ifdef NEVER

 }
 else
 {

  if(trans->c==0 && trans->b==0)
  {
   x=trans->e>>8;
   y=trans->f>>8;

   pt.x=x;
   pt.y=y;
   LPtoDP(currenthdcptr->hdc,&pt,1);
   x=pt.x;
   y=pt.y;
 
// graphicsostext2(currenthdcptr);

// y-=sph->height;

 factors.xmag=trans->a;
 factors.xdiv=scale(0x10000,xdpi,cvdu.xdpi);
 factors.ymag=trans->d;
 factors.ydiv=scale(0x10000,ydpi,cvdu.ydpi);



 sprite_renderscaled(sph,currenthdcptr->hdc,x,y,&factors,pixtrans);   // x,y top left of sprite

// graphicsriscos2(currenthdcptr);
#endif
 return(NULL);
}

#endif



os_error * sprite_put_transproc(sprite_area *area,sprite_id *spr,int gcol_action,
                            sprite_transform * trans,processstr * prc,sprite_pixtrans *pixtrans)
{
	os_error       * err;
 newsprite_header  * sph;
 POINT            pts[4];
 int              xdpi;
 int              ydpi;
 int              xpix;
 int              ypix;
 coordstr       * cx;
 int              i;
 int              regular;

 setfromtag(area,spr,&sph);

 if(gcol_action & (1<<8))
 {
  cx=(coordstr*)trans;

  for(i=0;i<4;i++)
  {
   pts[i].x=GRDXPIX(cx[i].x);
   pts[i].y=GRDYPIX(cx[i].y);
  }
 }
 else
 {
  getspriteinfo((newsprite_header*)sph,&xdpi,&ydpi,NULL);
  getspritesize((newsprite_header*)sph,&xpix,&ypix,NULL);

  pts[0].x=0;
  pts[0].y=(ypix*180*256)/ydpi;
  pts[1].x=(xpix*180*256)/xdpi;
  pts[1].y=pts[0].y;
  pts[2].x=pts[1].x;
  pts[2].y=0;
  pts[3].x=0;
  pts[3].y=0;

  tr_transformset((coordstr*)pts,4,(transformstr*)trans);

  for(i=0;i<4;i++)
  {
   pts[i].x=GRDXPIX(pts[i].x);
   pts[i].y=GRDYPIX(pts[i].y);
  }
 }


  regular=(pts[0].y==pts[1].y && pts[2].y==pts[3].y &&
           pts[0].x==pts[3].x && pts[1].x==pts[2].x);

  if(regular)
  {
   err=sprite_renderscaled(sph,currenthdcptr->hdc,pts[0].x,pts[3].y,pts[1].x-pts[0].x,pts[3].y-pts[0].y,pixtrans,prc);   // x,y top left of sprite
  }
  else
  {
   err=sprite_renderbox(sph,currenthdcptr,pts,pixtrans,prc);
  }

 
 return(err);
}



os_error * sprite_put_trans(sprite_area *area,sprite_id *spr,int gcol_action,
                            sprite_transform * trans,sprite_pixtrans *pixtrans)
{

	return(sprite_put_transproc(area,spr,gcol_action,trans,NULL,pixtrans));
}




os_error * sprite_readsize(sprite_area *area, sprite_id *spr,
                           sprite_info *resultinfo)
{
 newsprite_header * sph;
 int             spbpp;
 int             bitwidth;

 setfromtag(area,spr,&sph);

 getspriteinfo((newsprite_header*)sph,NULL,NULL,&spbpp);
 bitwidth=32*(sph->width+1)-sph->lbit-(31-sph->rbit);

 resultinfo->width=bitwidth/spbpp;
 resultinfo->height=sph->height+1;
 resultinfo->mask=(sph->mask>sph->image);
 resultinfo->mode=sph->selector.mode.mode;

// cprintf("mode %x %x",resultinfo->mode,sph->mode);

 return(NULL);
}




