/*->c.wimpt */

#include <stdafx.h>


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>

#include "os.h"
#include "werr.h"
#include "wimpt.h"






static char *programname = "";
static char *programtextname;
static char *programspritename;


char * wimpt_programname(void)
{
 return(programname);
}


char * wimpt_programtextname(void)
{
 return(programtextname?programtextname:programname);
}


char * wimpt_programsprite(void)
{
 return(programspritename);
}



static void wimpt__exit(void)
{

}





/*****************************************************************************/

/* in production versions, we use these signal handlers      */
/* the escape one is used during printing, and does nothing  */
/* the other one prints up an error message and then resumes */

static void escape_handler(int sig)
{
 (void) signal(SIGINT, &escape_handler);
 /* reinstall ourselves, as SIG_DFL has been restored by the system: */
 /* as defined by the (dumb) ANSI spec! */
 sig=0;
}



static crashfn crash;


static void general_handler(int sig)
{
 char string[128];
 sprintf(string,"%s has suffered an internal error type=%d.",programname,sig);
 errorbox(string);

 if(crash) crash();

 (void) signal(sig, &general_handler);
 exit(0);
}


void wimpt_setcrash(crashfn xcrash)
{
 crash=xcrash;
}



static int wimpversioninit=200;


void wimpt_wimpversion(int version)
{
 wimpversioninit=version;
}


int wimpt_init(char *progname)
{
 int version;

#ifndef _DEBUG
/*
 signal(SIGINT,  &escape_handler);
 signal(SIGABRT, &general_handler);
 signal(SIGFPE,  &general_handler);
 signal(SIGILL,  &general_handler);
 signal(SIGSEGV, &general_handler);
 signal(SIGTERM, &general_handler);
*/
#endif

 version=wimpversioninit;
 programname = progname;

 atexit(wimpt__exit);

 return(version);
}


int wimpt_init2(char *progname,char * textname,char * spritename)
{
 programspritename=spritename;
 programtextname=textname;
 return(wimpt_init(progname));
}







