/*->c.xmath */

#include <stdafx.h>

#include "math.h"

#include "xmath.h"

inline int  fastdiv400(int n)
{
 return(n/400);
}


// int x=squareroot(int n,int scale)  x=sqrt(n)*(1<<scale);

int  squareroot(int n,int scale)
{
 return((int)(sqrt((double)n)*(1<<scale)));

}


int  bigsquareroot(big * n)
{
 __int64 temp;

 temp=(((__int64)(n->hi))<<32)|(n->lo);

 return((int)sqrt((double)temp));
}


void bigmul(big * n,int n1,int n2)
{
 __int64 temp;

 temp=((__int64)n1)*((__int64)n2);
 n->hi=(int)(temp>>32);
 n->lo=(int)(temp);
}

int  bigdiv(big * n,int divider)
{
 __int64 temp;

 temp=(((__int64)(n->hi))<<32)|(n->lo);
 temp=temp/divider;
 return((int)temp);
}


void bigadd(big * n1,big * n2,big * result)
{
 __int64 temp1;
 __int64 temp2;

 temp1=(((__int64)(n1->hi))<<32)|(n1->lo);
 temp2=(((__int64)(n2->hi))<<32)|(n2->lo);

 temp1=temp1+temp2;

 result->hi=(int)(temp1>>32);
 result->lo=(int)temp1;
}


void bigsub(big * n1,big * n2,big * result)
{
 __int64 temp1;
 __int64 temp2;

 temp1=(((__int64)(n1->hi))<<32)|((__int64)(n1->lo));
 temp2=(((__int64)(n2->hi))<<32)|((__int64)(n2->lo));

 temp1=temp1-temp2;

 result->hi=(int)(temp1>>32);
 result->lo=(int)temp1;



}



int scale(int x,int mul,int div)
{
 return(MulDiv(x,mul,div));
/* 
 __int64 temp;

 temp=((__int64)x*(__int64)mul);
 temp=temp/div;

 return((int)temp);
 */
}


int  scalenr(int x,int mul,int div)
{
 __int64 temp;

 temp=((__int64)x*(__int64)mul);
 temp=temp/div;

 return((int)temp);
}


//  return a1*a2/0x10000
//
//  implies we don't care about bottom 16 bits or top 16 bits


int  ttmul(int t1,int t2)
{
 return(scale(t1,t2,0x10000));
}



/* x=sqrt(a*a+b*b) */
/*
int pythag(int a,int b)
{
 big a2;
 big b2;
 big sum;

 if(b==0) return(ABS(a));
 else
 if(a==0) return(ABS(b));
 else
 {
  bigmul(&a2,a,a);
  bigmul(&b2,b,b);
  bigadd(&a2,&b2,&sum);
  return(bigsquareroot(&sum));
 }
}
*/



int  pythag(int a,int b)
{
 return((int)sqrt((double)a*(double)a+(double)b*(double)b));


}





/* y=sqrt(r*r-x*x) */ 
/*
int pythagd(int r,int x)
{
 big a2;
 big b2;
 big diff;

 if(x==0) return(ABS(r));
 else
 {
  bigmul(&a2,r,r);
  bigmul(&b2,x,x);
  bigsub(&a2,&b2,&diff);
  return(bigsquareroot(&diff));
 }
}
*/




int  pythagd(int r,int x)
{
 return((int)sqrt((double)r*(double)r-(double)x*(double)x));

}




int scaleatan2(int x,int y)
{
 int angle;

 if(y) angle=(int)((180*atan2((double)x,(double)y)/PI)*0x10000);
 else  
 {
  if(x<0) angle=-90*0x10000;
  else
  if(x>0) angle=90*0x10000;
  else    angle=0;
 }

 return(angle);
}


int scaleatan(int t)
{
 int angle;

 angle=(int)(180.0*(double)0x10000*atan((double)t/(double)0x10000)/PI);

 return(angle);
}




void bignormalise(big * top,big * bot)
{
 int toplo;
 int tophi;
 int botlo;
 int bothi;
 int shift;
 int temp;

 toplo=top->lo;
 tophi=top->hi;
 botlo=bot->lo;
 bothi=bot->hi;

 temp=0;

 while(1)
 {
  if(bothi==-1)
  {
   if(botlo<0)
   {
    if(temp==0)   // normtest 2
    {
     temp=botlo;
     shift=0;
    }

    if(tophi==-1)  // normtest 3
    {
     if(toplo<0) break;
    }
    else          // norm2
    {
     if(tophi==0)
     {
      if(toplo>=0) break;
     }
    }
   }
  }
  else
  {
   if(bothi==0)
   {
    if(botlo>=0)
    {
     if(temp==0)
     {
      temp=botlo;
      shift=0;
     }

     if(tophi==-1)  // normtest 3
     {
      if(toplo<0) break;
     }
     else          // norm2
     {
      if(tophi==0)
      {
       if(toplo>=0) break;
      }
     }
    }
   }
  }

// normalise
  toplo=toplo>>1;
  toplo&=~0x80000000;
  if(tophi&0x1) toplo|=0x80000000;
  tophi=tophi>>1;

  botlo=botlo>>1;
  botlo&=~0x80000000;
  if(bothi&0x1) botlo|=0x80000000;
  bothi=bothi>>1;

  shift++;
 }

//normalised

//  shift=shifts past 32 bits for bottom
//  temp=32 bit bottom  (max 32 bit exact value)
//  multiply top by (bottom & ~ (1<<shift)-1)/bottom
 bot->hi=botlo;
 top->hi=(int)(((__int64)toplo*(__int64)(botlo<<shift))/temp);
}

